﻿var strategy, clusters, exposureLayer;
var maps = {}; 
var createMap = function (divId) {
    var map;
    map = new OpenLayers.Map({
        div: "map1",
        projection: new OpenLayers.Projection("EPSG:900913")
    });

    var osm = new OpenLayers.Layer.OSM("OSM");

    map.addLayers([osm]);
    map.setCenter(
       new OpenLayers.LonLat(-112.675781, 38.272689).transform(
           new OpenLayers.Projection("EPSG:4326"),
           map.getProjectionObject()
       ),
       5
   );
    return map;
};


$(document).ready(function () {
    var map1 = createMap("map1");
    maps["map1"] = map1;
    $(".ara-Change-Base-Map").click(function () {
        ChangeBaseMap(this.innerHTML);
    });
    $(".ara-Add-wms-Layer").click(function () {
        addWmsLayer();
    });
    $("#btnGetExposures").click(function (e) {
        var Year = $("#DataYear").val();
        var AccountName = $("#Accounts").val();
        var AccountGroupName;
        var DbName;

        var obj = $("#Accounts").data("ejAutocomplete");
        var source = obj.option("dataSource");
        var id = 0;
        for (var i = 0; i < source.length; i++) {
            if (source[i].AccountGroupName == AccountName) {
                DbName = source[i].DBname;
                break;
            }
        }
        $.ajax({
            type: "Get",
            url: "/Exposure/GetAllExposures",
            data: { "AccountGroupName": AccountName, "DbName": DbName, "Year": Year },
            success: function (result) {
                PlotExposuresOnMap(result);
            },

        });

    });

    $("#AddLayers").click(function (e) {
        if (window.showModalDialog) {
            window.showModalDialog("AddLayers", "", "center=yes, dialogWidth:600px;dialogHeight:600px");
        } else {
            window.open('AddLayers', '', 'height=600,width=600,toolbar=no,directories=no,status=no,continued from previous linemenubar=no,scrollbars=no,resizable=no ,modal=yes');
        }
    });
});

var ChangeBaseMap = function (baseType) {
    switch (baseType) {
        case "Google Map":
            var gmap = new OpenLayers.Layer.Google("Google Streets");
            maps["map1"].addLayers([gmap]);
            maps["map1"].setBaseLayer(gmap);
            break;
        case "Bing Map":
            var bingRoad = new OpenLayers.Layer.Bing({
                name: "Road",
                key: "AqTGBsziZHIJYYxgivLBf0hVdrAk9mWO5cQcb8Yux8sW5M8c8opEC2lZqKR1ZZXf",
                type: "Road"
            });
            maps["map1"].addLayers([bingRoad])
            maps["map1"].setBaseLayer(bingRoad);
            break;
        case "OpenStreetMap":
            var osm = new OpenLayers.Layer.OSM();
            maps["map1"].addLayers([osm]);
            maps["map1"].setBaseLayer(osm);
            break;
        default:
            var osm = new OpenLayers.Layer.OSM();
            maps["map1"].addLayers([osm]);
            maps["map1"].setBaseLayer(osm);
            break;
    }
    //addWmsLayer("Hazard Layer", "Hazards", "Hazards:hazfaults2014_proj");
}


var addWmsLayer = function (title, workspace, wmsLayers) {
    var wmsUrl = mapServerURL + "/" + workspace + "/wms";
    var legendURL = "\"<img src='" + mapServerURL + "/" + workspace + "/wms?REQUEST=GetLegendGraphic&VERSION=1.0.0&FORMAT=image/png&WIDTH=20&HEIGHT=20&LAYER=" + wmsLayers + "'/>";

    var overLay = new OpenLayers.Layer.WMS(
        title, wmsUrl, { layers: wmsLayers, transparent: 'true', style: '', format: 'image/png' }, { 'attribution': legendURL }
        );

    overLay.isBaseLayer = false;

    maps["map1"].addLayer(overLay);

}

function PlotExposuresOnMap(selectedExposures) {
    if (exposureLayer)
        maps["map1"].removeLayer(exposureLayer);


    var clusterStrategy = new OpenLayers.Strategy.Cluster({ distance: 20 });

    var geojson_format = new OpenLayers.Format.GeoJSON({
        'internalProjection': new OpenLayers.Projection("EPSG:900913"),
        'externalProjection': new OpenLayers.Projection("EPSG:4326")
    });
    exposureLayer = new OpenLayers.Layer.Vector("Exposures", { strategies: [clusterStrategy] });

    maps["map1"].addLayer(exposureLayer);
    exposureLayer.addFeatures(geojson_format.read(selectedExposures));

}

